#ifndef __UTIL_H__
#define __UTIL_H__

#include <digitalSTROM/ds485.h>
#include <digitalSTROM/ds485-socket-server.h>

double timestamp(void);
int daemonize(void);
int sscanf_port(const char* str_port);
int service_to_port(const char *service, const char *protocol);
int passivesock(int port, char *protocol, int qlen, int listenGlobal);

int snprintf_peername(char *buf, int len, int fd);
int sprintf_dsuid(char *buf, const dsuid_t *id);
#define DSUID_STR_BUF(buf)  char buf[2 * sizeof(dsuid_t) + 1]

/** scan dsuid from parameter to program
 * @param buf  -- string with format "23f232432343.." 24 bytes
 * @param dsuid -- output
 * @ret  -- 0 on success
 */
int scanf_dsuid(const char *buf, dsuid_t *dsuid);

/**
 * sprintf_container -- dumps src / dest address, transactionID
 * and first 16 bytes of content
 * @param buf holds result, NULL is valid input see sprintf
 * @param container to be dumped
 * @return the number of bytes written
 * Use CONTAINER_STR_BUF to allocate large enough buffer
 */
int sprintf_container(char *buf, const ds485_container_t *container);
int sprintf_netlib_packet(char *buf, const ds485n_packet_t *packet);
#define CONTAINER_STR_BUF(buf)  char buf[256] /* TODO magic number */

#endif
